#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

struct dvojka
{
    int x, y;
    dvojka() {}
    dvojka(int a, int b)
    {
        x=a;
        y=b;
    }
};

int n, m;
char c[702][702];
int ex, ey;
int px, py;
int sx, sy;
int dostp[702][702];
int minstp[702][702];
int pot[702][702][2];
int brpot=0;

queue<dvojka> qu;

bool cmp(dvojka p, dvojka q)
{
    return dostp[p.x][p.y]<dostp[q.x][q.y];
}

dvojka mdv[500000];

void bfs()
{
    dostp[px][py]=0;
    qu.push(dvojka(px, py));
    while(!qu.empty())
    {
        int tx=qu.front().x, ty=qu.front().y;
        qu.pop();
        if(c[tx+1][ty]!='*' && dostp[tx][ty]+1<dostp[tx+1][ty]) dostp[tx+1][ty]=dostp[tx][ty]+1, qu.push(dvojka(tx+1, ty));
        if(c[tx-1][ty]!='*' && dostp[tx][ty]+1<dostp[tx-1][ty]) dostp[tx-1][ty]=dostp[tx][ty]+1, qu.push(dvojka(tx-1, ty));
        if(c[tx][ty+1]!='*' && dostp[tx][ty]+1<dostp[tx][ty+1]) dostp[tx][ty+1]=dostp[tx][ty]+1, qu.push(dvojka(tx, ty+1));
        if(c[tx][ty-1]!='*' && dostp[tx][ty]+1<dostp[tx][ty-1]) dostp[tx][ty-1]=dostp[tx][ty]+1, qu.push(dvojka(tx, ty-1));
    }
}

void updatedv(int id)
{
    dvojka tdv=mdv[id];
    if(!pot[tdv.x][tdv.y][0])
    {
        pot[tdv.x][tdv.y][0]=1;
        int nx=tdv.x, ny=tdv.y;
        while(c[nx][ny]!='*')
        {
            pot[nx][ny][0]=1;
            if(minstp[nx][ny]>dostp[tdv.x][tdv.y]) minstp[nx][ny]=dostp[tdv.x][tdv.y];
            nx++;
        }
        nx=tdv.x-1, ny=tdv.y;
        while(c[nx][ny]!='*')
        {
            pot[nx][ny][0]=1;
            if(minstp[nx][ny]>dostp[tdv.x][tdv.y]) minstp[nx][ny]=dostp[tdv.x][tdv.y];
            nx--;
        }
    }
    if(!pot[tdv.x][tdv.y][1])
    {
        pot[tdv.x][tdv.y][1]=1;
        int nx=tdv.x, ny=tdv.y;
        while(c[nx][ny]!='*')
        {
            pot[nx][ny][1]=1;
            if(minstp[nx][ny]>dostp[tdv.x][tdv.y]) minstp[nx][ny]=dostp[tdv.x][tdv.y];
            ny++;
        }
        nx=tdv.x, ny=tdv.y-1;
        while(c[nx][ny]!='*')
        {
            pot[nx][ny][1]=1;
            if(minstp[nx][ny]>dostp[tdv.x][tdv.y]) minstp[nx][ny]=dostp[tdv.x][tdv.y];
            ny--;
        }
    }
}

int res[702][702];

queue<dvojka> qu2;

void new_dfs()
{
    for(int i=1; i<=n; i++)
        for(int j=1; j<=m; j++) res[i][j]=1000000000;
    res[ex][ey]=0;
    qu2.push(dvojka(ex, ey));
    while(!qu2.empty())
    {
        int tx=qu2.front().x, ty=qu2.front().y;
        qu2.pop();
        if(c[tx+1][ty]!='*' && res[tx][ty]+1<minstp[tx+1][ty] && res[tx][ty]+1<res[tx+1][ty]) res[tx+1][ty]=res[tx][ty]+1, qu2.push(dvojka(tx+1, ty));
        if(c[tx-1][ty]!='*' && res[tx][ty]+1<minstp[tx-1][ty] && res[tx][ty]+1<res[tx-1][ty]) res[tx-1][ty]=res[tx][ty]+1, qu2.push(dvojka(tx-1, ty));
        if(c[tx][ty+1]!='*' && res[tx][ty]+1<minstp[tx][ty+1] && res[tx][ty]+1<res[tx][ty+1]) res[tx][ty+1]=res[tx][ty]+1, qu2.push(dvojka(tx, ty+1));
        if(c[tx][ty-1]!='*' && res[tx][ty]+1<minstp[tx][ty-1] && res[tx][ty]+1<res[tx][ty-1]) res[tx][ty-1]=res[tx][ty]+1, qu2.push(dvojka(tx, ty-1));
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    memset(c, '*', sizeof(c));
    cin>>n>>m;
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cin>>c[i][j];
            if(c[i][j]=='E')
            {
                ex=i;
                ey=j;
            }
            if(c[i][j]=='P')
            {
                px=i;
                py=j;
            }
            if(c[i][j]=='S')
            {
                sx=i;
                sy=j;
            }
            dostp[i][j]=1000000000;
            mdv[(i-1)*m+j-1]=dvojka(i, j);
            minstp[i][j]=1000000000;
        }
    }
    bfs();
    dostp[px][py]=1;
    sort(mdv, mdv+n*m, cmp);
    for(int i=0; i<n*m; i++)
    {
        updatedv(i);
        if(brpot==n*m) break;
    }
    new_dfs();
    if(res[sx][sy]!=1000000000) cout<<"YES\n";
    else cout<<"NO\n";
    return 0;
}
