#include <iostream>
#include <algorithm>
#define int __int128
using namespace std;
const int maxn = 20;

struct cheese {
    int a, b, c;
    cheese(){}
    cheese(int _a, int _b, int _c) {
        a = _a; b = _b; c = _c;
    }
} c[maxn];

int d, k, curr;

long long n, d1, k1, curr_a, curr_b, curr_c;

int cut_to;

int binary(int ix) {
    int l = 1, r = (c[ix].a / d) + 1, mid;
    while (l < r - 1) {
        mid = (l+r)/2;
        //cout << "l, r, mid: " << l << ' ' << r << ' ' << mid << ' ' << c[ix].b << ' ' << c[ix].c << ' ' << (c[ix].a - d*mid) << '\n';
        if (c[ix].b * c[ix].c * (c[ix].a - d*(mid-1)) > k) l = mid;
        else r = mid;
    }
    return l;
}

signed main () {
    cin >> n >> d1 >> k1;
    d = d1; k = k1;
    
    for (int i = 1 ; i <= n ; ++i) {
        cin >> curr_a >> curr_b >> curr_c;
        c[i].a = curr_a;
        c[i].b = curr_b;
        c[i].c = curr_c;
        if (c[i].a < c[i].b) swap(c[i].a, c[i].b);
        if (c[i].a < c[i].c) swap(c[i].a, c[i].c);
    }

    for (int i = 1 ; i <= n ; ++i) {
        if (c[i].a < d || c[i].a * c[i].b * c[i].c <= k) {
            cout << 0 << '\n';
            continue;
        }
        //cout << "cheese: " << c[i].a << ' ' << c[i].b << ' ' << c[i].c << '\n';
        curr = binary(i);
        cout << (long long)curr << '\n';
    }

    return 0;

}

/*
2
2
1
1 1 2
5 4 3

5
2
30
5 4 3
1 1 1
3 2 1
10 3 7
4 8 9
*/