#include <iostream>
#include <algorithm>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
#define int long long
using namespace std;
const int maxn = 20, buff_size = 2e5+10;


char buff[buff_size];
int buff_ix = buff_size-1;
void read_char() {
    if (++buff_ix == buff_size) fread(buff, buff_size, 1, stdin), buff_ix = 0;
}
void read_int(int &ret) {
    ret = 0;
    for (; buff[buff_ix] < '0' || '9' < buff[buff_ix]; read_char());
    for (; '0' <= buff[buff_ix] && buff[buff_ix] <= '9'; read_char())
        ret = 10*ret + buff[buff_ix] - '0';
}

struct cheese {
    int a, b, c;
    cheese(){}
    cheese(int _a, int _b, int _c) {
        a = _a; b = _b; c = _c;
    }
} c;

int d, k, curr;

long long n, d1, k1, curr_a, curr_b, curr_c, res;

int cut_to;

int binary(int ix) {
    int l = 0, r = (c.a - c.b) / d + 2, mid, bc = c.b * c.c;
    while (l < r - 1ll) {
        mid = (l+r)/2ll;
        //cout << "l, r, mid: " << l << ' ' << r << ' ' << mid << ' ' << c.b << ' ' << c.c << ' ' << (c.a - d*mid) << '\n';
        if (bc > k / (c.a - d*(mid-1))) l = mid;
        else r = mid;
    }
    return l;
}

signed main () {
    ios_base :: sync_with_stdio(0);
    cout.tie(nullptr);
    read_int(n);
    read_int(d);
    read_int(k);
    
    for (int i = 1 ; i <= n ; ++i) {
        read_int(c.a);
        read_int(c.b);
        read_int(c.c);
        if (c.a < c.b) swap(c.a, c.b);
        if (c.a < c.c) swap(c.a, c.c);
        if (c.b < c.c) swap(c.b, c.c);

        curr = 0;

        while (c.c > 0 && c.a * c.b > k/c.c && c.a >= d && c.b > 0) {

            res = binary(i);
            curr += res;
            c.a -= res*d;
            if (c.a < c.b) swap(c.a, c.b);
            if (c.b < c.c) swap(c.b, c.c);
   
            //cout << "after binary: " << c.a << ' ' << c.b << ' ' << c.c << '\n';

        }

        cout << curr << '\n';

    }

    return 0;

}

/*
2
2
1
1 1 2
5 4 3

3
2
30
7 4 3
1 1 1
3 2 1
10 3 7
4 8 9
*/