#include <iostream>
#include <algorithm>
#include <bitset>
using namespace std;
const int maxn = 1e4+10, buff_size = 2e5+10;


char buff[buff_size];
int buff_ix = buff_size-1;
void read_char() {
    if (++buff_ix == buff_size) fread(buff, buff_size, 1, stdin), buff_ix = 0;
}
void read_int(int &ret) {
    ret = 0;
    for (; buff[buff_ix] < '0' || '9' < buff[buff_ix]; read_char());
    for (; '0' <= buff[buff_ix] && buff[buff_ix] <= '9'; read_char())
        ret = 10*ret + buff[buff_ix] - '0';
}

pair < int, int > sorted[maxn];
int compr_cnt;

bitset < maxn > bs;

int a[maxn], n, q;
int l, r;

signed main () {
    ios_base :: sync_with_stdio(0);
    cout.tie(nullptr);
    read_int(n);

    for (int i = 1 ; i <= n ; ++i) {
        read_int(a[i]);
        sorted[i] = {a[i], i};
    }
    sort(sorted+1, sorted+1+n);

    for (int i = 1 ; i <= n ; ++i) {
        compr_cnt += (sorted[i].first != sorted[i-1].first);
        a[sorted[i].second] = compr_cnt;
    }

    read_int(q);
    for (int i = 1 ; i <= q ; ++i) {
        bs.reset();
        read_int(l); read_int(r);
        for (int j = l ; j <= r ; ++j) bs[a[j]] = 1;
        cout << bs.count() << '\n';

    }

    return 0;

}

/*
2
2
1
1 1 2
5 4 3
*/