#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")
using namespace std;
typedef long long ll;
const int maxn = 1e6 + 10;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, q, a[maxn], nxt[maxn];
vector < int > v[4 * maxn];

void read()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
        cin >> a[i];
}

void merge_tree(int root, int idx1, int idx2)
{
    int p1 = 0, p2 = 0, sz1 = v[idx1].size(), sz2 = v[idx2].size();
    while(p1 < sz1 || p2 < sz2)
    {
        if (p1 == sz1)
            v[root].push_back(v[idx2][p2 ++]);
        else
        if (p2 == sz2)
            v[root].push_back(v[idx1][p1 ++]);
        else
        {
            if (v[idx1][p1] < v[idx2][p2])
                v[root].push_back(v[idx1][p1 ++]);
            else
                v[root].push_back(v[idx2][p2 ++]);
        }
    }
}

void build_tree(int root, int left, int right)
{
    if (left == right)
    {
        if (nxt[left] != n + 1)
        v[root].push_back(nxt[left]);
    }
    else
    {
        int mid = (left + right) / 2;
        build_tree(root * 2, left, mid);
        build_tree(root * 2 + 1, mid + 1, right);
        merge_tree(root, root * 2, root * 2 + 1);
    }
}

int query(int root, int left, int right, int &qleft, int &qright)
{
    if (left > qright || right < qleft)
        return 0;
    if (left >= qleft && right <= qright)
    {
        int l = 0, r = v[root].size() - 1;
        while(l <= r)
        {
            int m = (l + r) / 2;
            if (v[root][m] > qright)
                r = m - 1;
            else
                l = m + 1;
        }
        return r + 1;
    }

    int mid = (left + right) / 2;
    return query(root * 2, left, mid, qleft, qright) +
            query(root * 2 + 1, mid + 1, right, qleft, qright);
}
void solve()
{
    unordered_map < int, int > mp;
    for (int i = n; i > 0; i --)
    {
        if (mp[a[i]] == 0)
            nxt[i] = n + 1;
        else
            nxt[i] = mp[a[i]];
        mp[a[i]] = i;
    }

    build_tree(1, 1, n);

    cin >> q;
    for (int i = 1; i <= q; i ++)
    {
        int l, r;
        cin >> l >> r;
        cout << (r - l + 1) - query(1, 1, n, l, r) << endl;
    }
}
int main()
{
    speed();
    read();
    solve();
    return 0;
}

