#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("-O3")
using namespace std;
typedef long long ll;
const int maxn = 1e6 + 10;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, q, a[maxn], nxt[maxn];
int tree[maxn * 4];

struct query
{
    int l, r, idx, ans;
}qu[maxn];

bool cmp(query q1, query q2)
{
    if (q1.l < q2.l)
        return true;
    if (q1.l > q2.l)
        return false;
    return q2.r < q2.r;
}

bool cmpidx(query q1, query q2)
{
    return q1.idx < q2.idx;
}

void read()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
        cin >> a[i];
}

void update(int root, int left, int right, int idx, int val)
{
    if (left == right)
    {
        tree[root] += val;
        return;
    }

    int mid = (left + right) / 2;
    if (idx <= mid)
        update(root * 2, left, mid, idx, val);
    else
        update(root * 2 + 1, mid + 1, right, idx, val);

    tree[root] = tree[root * 2] + tree[root * 2 + 1];
}

int query(int root, int left, int right, int qleft, int qright)
{
    if (left > qright || right < qleft)
        return 0;
    if (left >= qleft && right <= qright)
        return tree[root];

    int mid = (left + right) / 2;
    return query(root * 2, left, mid, qleft, qright) +
            query(root * 2 + 1, mid + 1, right, qleft, qright);
}

void solve()
{
    unordered_map < int, int > mp;
    for (int i = n; i > 0; i --)
    {
        if (mp[a[i]] == 0)
            nxt[i] = n + 1;
        else
            nxt[i] = mp[a[i]];
        mp[a[i]] = i;
    }

    for (int i = 1; i <= n; i ++)
    {
        if (nxt[i] != n + 1)
        update(1, 1, n, nxt[i], 1);
    }

    cin >> q;
    for (int i = 1; i <= q; i ++)
    {
        cin >> qu[i].l >> qu[i].r;
        qu[i].idx = i;
    }

    sort(qu + 1, qu + q + 1, cmp);

    int pos = 1, i = 1;
    while(i <= q)
    {
        while(pos < qu[i].l)
        {
            if (nxt[pos] != n + 1)
            update(1, 1, n, nxt[pos], -1);
            pos ++;
        }

        while(qu[i].l == pos)
            qu[i].ans = query(1, 1, n, qu[i].l, qu[i].r), i ++;
    }

    sort(qu + 1, qu + q + 1, cmpidx);

    for (int i = 1; i <= q; i ++)
        cout << (qu[i].r - qu[i].l + 1) - qu[i].ans << endl;
}
int main()
{
    speed();
    read();
    solve();
    return 0;
}

