#include<iostream>
#include<vector>
#define endl '\n'
using namespace std;
long long a[1000000];
struct str
{
    long long t;
    vector<int>v;
}tree[4000000];
void build_tree(long long l,long long r,long long node)
{
    if(l==r)
    {
        tree[node].t=1;
        tree[node].v.push_back(a[l]);
        return;
    }
    int mid=(l+r)/2;

    build_tree(l,mid,2*node);
    build_tree(mid+1,r,2*node+1);

    for(int i=0;i<tree[2*node].v.size();i++)
    {
        bool p=false;
        for(int j=0;j<tree[node].v.size();j++)
        {
            if(tree[node].v[j]==tree[2*node].v[i])
            {
                p=true;break;
            }
        }
        if(!p)tree[node].v.push_back(tree[2*node].v[i]);
    }

    for(int i=0;i<tree[2*node+1].v.size();i++)
    {
        bool p=false;
        for(int j=0;j<tree[node].v.size();j++)
        {
            if(tree[node].v[j]==tree[2*node+1].v[i])
            {
                p=true;break;
            }
        }
        if(!p)tree[node].v.push_back(tree[2*node+1].v[i]);
    }


}
vector<int>k;
vector<int> query(long long le,long long ri,long long l,long long r,long long ind)
{

    if(le>r || ri<l)return k;
    if(l<=le && ri<=r)
    {
        return tree[ind].v;
    }
    int mid=(le+ri)/2;

    vector<int>v1=query(le,mid,l,r,ind*2), v2= query(mid+1,ri,l,r,2*ind+1),re;

    re=v2;
  for(int i=0;i<v1.size();i++)
    {
        bool p=false;
        for(int j=0;j<re.size();j++)
        {
            if(v1[i]==re[j])
            {
                p=true;break;
            }
        }
        if(!p)re.push_back(v1[i]);
    }
    return re;


}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n,i,q,l,r;
    cin>>n;

    for(i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    build_tree(1,n,1);
    cin>>q;

    for(i=0;i<q;i++)
    {
        cin>>l>>r;

        cout<<query(1,n,l,r,1).size()<<endl;
    }


}
